package org.apache.xindice.client.corba.db;

//
// Helper class for : Names
//
// @author OpenORB Compiler
//
public class NamesHelper
{
	private static final boolean HAS_OPENORB;
	static {
		boolean hasOpenORB = false;
		try {
			Class.forName("org.openorb.CORBA.Any");
			hasOpenORB = true;
		}
		catch(ClassNotFoundException ex) {
		}
		HAS_OPENORB = hasOpenORB;
	}
	//
	// Insert Names into an any
	// @param	a an any
	// @param	t Names value
	//
	public static void insert( org.omg.CORBA.Any a, String[] t )
	{
		a.insert_Streamable( new org.apache.xindice.client.corba.db.NamesHolder( t ));
	}

	//
	// Extract Names from an any
	// @param	a an any
	// @return the extracted Names value
	//
	public static String[] extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		if(HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
			// streamable extraction. The jdk stubs incorrectly define the Any stub
			org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
			try {
				org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
				if(s instanceof org.apache.xindice.client.corba.db.NamesHolder)
					return ((org.apache.xindice.client.corba.db.NamesHolder)s).value;
			}
			catch ( org.omg.CORBA.BAD_INV_ORDER ex ) {}
			org.apache.xindice.client.corba.db.NamesHolder h = new org.apache.xindice.client.corba.db.NamesHolder(read(a.create_input_stream()));
			a.insert_Streamable(h);
			return h.value;
		}
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;

	//
	// Return the Names TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
			_tc = orb.create_alias_tc(id(),"Names",orb.create_sequence_tc(0,org.apache.xindice.client.corba.db.NameHelper.type()));
		}
		return _tc;
	}

	//
	// Return the Names IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:org/apache/xindice/client/corba/db/Names:1.0";

	//
	// Read Names from a marshalled stream
	// @param	istream the input stream
	// @return the readed Names value
	//
	public static String[] read( org.omg.CORBA.portable.InputStream istream )
	{
		String[] new_one;
		{
		int size1 = istream.read_ulong();
		new_one = new String[size1];
		for ( int i1=0; i1<new_one.length; i1++)
		 {
			new_one[i1] = org.apache.xindice.client.corba.db.NameHelper.read(istream);

		 }
		}

		return new_one;
	}

	//
	// Write Names into a marshalled stream
	// @param	ostream the output stream
	// @param	value Names value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, String[] value )
	{
		ostream.write_ulong(value.length);
		for ( int i1=0; i1<value.length; i1++)
		{
			org.apache.xindice.client.corba.db.NameHelper.write(ostream,value[i1]);

		}
	}

}
